#include <iostream>

using namespace std;

// Konstansok és típusok
const int MAXN = 8;
const int MAXDB = 100000;
typedef int Permutacio[MAXN];
typedef Permutacio PermutacioSorozat[MAXDB];

// Változók
int Db;
PermutacioSorozat Y;

bool Volt(const int i, const int j, const Permutacio x) {
  int k = 1;
  while (k < i and x[k - 1] != j) {
    k++;
  }
  return k < i;
}

bool Jo(Permutacio x) {
  return x[0] * 1000 +
         x[1] * 91 +
         x[2] * -90 +
         x[3] * 1 +
         x[4] * -9000 +
         x[5] * -900 +
         x[6] * 10 +
         x[7] * -1 == 0;
}

void Osszes_sorrend(const int i, const int N, int &Db, PermutacioSorozat Y, Permutacio x) {
  if (i == N + 1) {
    if (Jo(x)) {
      for (int j = 0; j < N; j++) {    // Y[Db] = x;
        Y[Db][j] = x[j];
      }
      Db++;
    }
  } else {
    int jj;
    if (i == 1 or i == 5) {
      jj = 1;
    } else {
      jj = 0;
    }
    for (int j = jj; j <= 9; j++) {
      if (!Volt(i, j, x)) {
        x[i - 1] = j;
        Osszes_sorrend(i + 1, N, Db, Y, x);
      }
    }
  }
}

void Megoldas(int &Db, PermutacioSorozat Y) {
  Permutacio x;
  Db = 0;
  Osszes_sorrend(1, 8, Db, Y, x);
}

void Kiiras(const int Db, const PermutacioSorozat Y) {
  const string szoveg = "SENDMORY";
  for (int i = 0; i < Db; i++) {
    for (int j = 0; j <= 7; j++) {
      cout << szoveg[j] << ":" << Y[i][j] << " ";
    }
    cout << endl;
  }
}

int main() {
  
  Megoldas(Db, Y);
  Kiiras(Db, Y);
  
  return 0;
}
